]> git.proxmox.com Git - mirror_ubuntu-jammy-kernel.git/blob - scripts/link-vmlinux.sh
s390/zcrypt: provide apfs failure code on type 86 error reply
[mirror_ubuntu-jammy-kernel.git] / scripts / link-vmlinux.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # link vmlinux
5 #
6 # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
7 # $(KBUILD_VMLINUX_MAIN) and $(KBUILD_VMLINUX_LIBS). Most are built-in.a files
8 # from top-level directories in the kernel tree, others are specified in
9 # arch/$(ARCH)/Makefile. Ordering when linking is important, and
10 # $(KBUILD_VMLINUX_INIT) must be first. $(KBUILD_VMLINUX_LIBS) are archives
11 # which are linked conditionally (not within --whole-archive), and do not
12 # require symbol indexes added.
13 #
14 # vmlinux
15 # ^
16 # |
17 # +-< $(KBUILD_VMLINUX_INIT)
18 # | +--< init/version.o + more
19 # |
20 # +--< $(KBUILD_VMLINUX_MAIN)
21 # | +--< drivers/built-in.a mm/built-in.a + more
22 # |
23 # +--< $(KBUILD_VMLINUX_LIBS)
24 # | +--< lib/lib.a + more
25 # |
26 # +-< ${kallsymso} (see description in KALLSYMS section)
27 #
28 # vmlinux version (uname -v) cannot be updated during normal
29 # descending-into-subdirs phase since we do not yet know if we need to
30 # update vmlinux.
31 # Therefore this step is delayed until just before final link of vmlinux.
32 #
33 # System.map is generated to document addresses of all kernel symbols
34
35 # Error out on error
36 set -e
37
38 # Nice output in kbuild format
39 # Will be supressed by "make -s"
40 info()
41 {
42 if [ "${quiet}" != "silent_" ]; then
43 printf " %-7s %s\n" ${1} ${2}
44 fi
45 }
46
47 # Thin archive build here makes a final archive with symbol table and indexes
48 # from vmlinux objects INIT and MAIN, which can be used as input to linker.
49 # KBUILD_VMLINUX_LIBS archives should already have symbol table and indexes
50 # added.
51 #
52 # Traditional incremental style of link does not require this step
53 #
54 # built-in.a output file
55 #
56 archive_builtin()
57 {
58 info AR built-in.a
59 rm -f built-in.a;
60 ${AR} rcsTP${KBUILD_ARFLAGS} built-in.a \
61 ${KBUILD_VMLINUX_INIT} \
62 ${KBUILD_VMLINUX_MAIN}
63 }
64
65 # Link of vmlinux.o used for section mismatch analysis
66 # ${1} output file
67 modpost_link()
68 {
69 local objects
70
71 objects="--whole-archive \
72 built-in.a \
73 --no-whole-archive \
74 --start-group \
75 ${KBUILD_VMLINUX_LIBS} \
76 --end-group"
77
78 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
79 }
80
81 # Link of vmlinux
82 # ${1} - optional extra .o files
83 # ${2} - output file
84 vmlinux_link()
85 {
86 local lds="${objtree}/${KBUILD_LDS}"
87 local objects
88
89 if [ "${SRCARCH}" != "um" ]; then
90 objects="--whole-archive \
91 built-in.a \
92 --no-whole-archive \
93 --start-group \
94 ${KBUILD_VMLINUX_LIBS} \
95 --end-group \
96 ${1}"
97
98 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
99 -T ${lds} ${objects}
100 else
101 objects="-Wl,--whole-archive \
102 built-in.a \
103 -Wl,--no-whole-archive \
104 -Wl,--start-group \
105 ${KBUILD_VMLINUX_LIBS} \
106 -Wl,--end-group \
107 ${1}"
108
109 ${CC} ${CFLAGS_vmlinux} -o ${2} \
110 -Wl,-T,${lds} \
111 ${objects} \
112 -lutil -lrt -lpthread
113 rm -f linux
114 fi
115 }
116
117
118 # Create ${2} .o file with all symbols from the ${1} object file
119 kallsyms()
120 {
121 info KSYM ${2}
122 local kallsymopt;
123
124 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
125 kallsymopt="${kallsymopt} --all-symbols"
126 fi
127
128 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
129 kallsymopt="${kallsymopt} --absolute-percpu"
130 fi
131
132 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
133 kallsymopt="${kallsymopt} --base-relative"
134 fi
135
136 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
137 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
138
139 local afile="`basename ${2} .o`.S"
140
141 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
142 ${CC} ${aflags} -c -o ${2} ${afile}
143 }
144
145 # Create map file with all symbols from ${1}
146 # See mksymap for additional details
147 mksysmap()
148 {
149 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
150 }
151
152 sortextable()
153 {
154 ${objtree}/scripts/sortextable ${1}
155 }
156
157 # Delete output files in case of error
158 cleanup()
159 {
160 rm -f .tmp_System.map
161 rm -f .tmp_kallsyms*
162 rm -f .tmp_vmlinux*
163 rm -f built-in.a
164 rm -f System.map
165 rm -f vmlinux
166 rm -f vmlinux.o
167 }
168
169 on_exit()
170 {
171 if [ $? -ne 0 ]; then
172 cleanup
173 fi
174 }
175 trap on_exit EXIT
176
177 on_signals()
178 {
179 exit 1
180 }
181 trap on_signals HUP INT QUIT TERM
182
183 #
184 #
185 # Use "make V=1" to debug this script
186 case "${KBUILD_VERBOSE}" in
187 *1*)
188 set -x
189 ;;
190 esac
191
192 if [ "$1" = "clean" ]; then
193 cleanup
194 exit 0
195 fi
196
197 # We need access to CONFIG_ symbols
198 case "${KCONFIG_CONFIG}" in
199 */*)
200 . "${KCONFIG_CONFIG}"
201 ;;
202 *)
203 # Force using a file from the current directory
204 . "./${KCONFIG_CONFIG}"
205 esac
206
207 # Update version
208 info GEN .version
209 if [ -r .version ]; then
210 VERSION=$(expr 0$(cat .version) + 1)
211 echo $VERSION > .version
212 else
213 rm -f .version
214 echo 1 > .version
215 fi;
216
217 # final build of init/
218 ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
219
220 archive_builtin
221
222 #link vmlinux.o
223 info LD vmlinux.o
224 modpost_link vmlinux.o
225
226 # modpost vmlinux.o to check for section mismatches
227 ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
228
229 kallsymso=""
230 kallsyms_vmlinux=""
231 if [ -n "${CONFIG_KALLSYMS}" ]; then
232
233 # kallsyms support
234 # Generate section listing all symbols and add it into vmlinux
235 # It's a three step process:
236 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
237 # but __kallsyms is empty.
238 # Running kallsyms on that gives us .tmp_kallsyms1.o with
239 # the right size
240 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
241 # the right size, but due to the added section, some
242 # addresses have shifted.
243 # From here, we generate a correct .tmp_kallsyms2.o
244 # 3) That link may have expanded the kernel image enough that
245 # more linker branch stubs / trampolines had to be added, which
246 # introduces new names, which further expands kallsyms. Do another
247 # pass if that is the case. In theory it's possible this results
248 # in even more stubs, but unlikely.
249 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
250 # other bugs.
251 # 4) The correct ${kallsymso} is linked into the final vmlinux.
252 #
253 # a) Verify that the System.map from vmlinux matches the map from
254 # ${kallsymso}.
255
256 kallsymso=.tmp_kallsyms2.o
257 kallsyms_vmlinux=.tmp_vmlinux2
258
259 # step 1
260 vmlinux_link "" .tmp_vmlinux1
261 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
262
263 # step 2
264 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
265 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
266
267 # step 3
268 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
269 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
270
271 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
272 kallsymso=.tmp_kallsyms3.o
273 kallsyms_vmlinux=.tmp_vmlinux3
274
275 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
276
277 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
278 fi
279 fi
280
281 info LD vmlinux
282 vmlinux_link "${kallsymso}" vmlinux
283
284 if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
285 info SORTEX vmlinux
286 sortextable vmlinux
287 fi
288
289 info SYSMAP System.map
290 mksysmap vmlinux System.map
291
292 # step a (see comment above)
293 if [ -n "${CONFIG_KALLSYMS}" ]; then
294 mksysmap ${kallsyms_vmlinux} .tmp_System.map
295
296 if ! cmp -s System.map .tmp_System.map; then
297 echo >&2 Inconsistent kallsyms data
298 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
299 exit 1
300 fi
301 fi